module.exports = function findAndPageAll(query,req,res,next){

    // Parse
    if (req.query.orderBy) req.query.orderBy = req.query.orderBy.split(",")
    if (req.query.orderDirection) req.query.orderDirection = req.query.orderDirection.split(",")
    if (req.query.limit) req.query.limit = Number(req.query.limit)
  
    const page = req.query.page || 1;
    const limit = req.query.limit || 10;
    const offset = (page - 1) * limit;
    const orderBy = req.query.orderBy || ["createdAt"];
    const orderDirection = req.query.orderDirection || ["DESC"];
  
    var order = [];
    orderBy.forEach((sb,i)=>{
      order.push( [ sb, orderDirection[i]  ] )
    })


    let opts = {
      where : {},
      limit: limit,
      offset : offset,
      order: order
    }
    // Override any options that are provided
    Object.keys(query).forEach(key=>{
      opts[key] = query[key]
    })

  
    return this.findAndCountAll(opts).then(data=>{
      data.page = page;
      data.count = data.count;
      data.limit = limit;
      data.totalPages = Math.ceil(data.count / limit),
      data.nextPage = (page < data.totalPages),
      data.prevPage = (page > 1)
      return data;
    }).then(paginated_data=>{

      return res.json({
        "data" : paginated_data
      })


    }).catch(next)


  }